SystemOrganization addCategory: #MagmaMemoryTest!

TestCase subclass: #MagmaMemoryTest
	instanceVariableNames: 'magmaSession'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MagmaMemoryTest'!

!MagmaMemoryTest commentStamp: '<historical>' prior: 0!
1. Evaluate:
	MagmaMemoryTest debug: #testMagmaImageSize
To run the test which add 50 "trees" with 5 of depth
2. If you want to customize the test parameters, please delete the repository previously created and evaluate
	MagmaMemoryTest debug: #testMagmaImageSizeParametrized !

!MagmaMemoryTest methodsFor: 'test' stamp: 'JMB 8/7/2007 17:28'!
addTestObjects: aNumber withDepth: depth forCollectionAt: aKey
		"add to magma collection at <aKey> aNumber test objects of depth <depth>"
	1 to: aNumber
		by: 5
		do: [: index | | aCollection |

					Transcript show: '--Iteration: ', index asString,'..',(index + 4) asString,': '; cr.
					Transcript show: 'Image size BEFORE creating test object: ', self imageSize; cr.
					Transcript show: 'Creating test objects...'; cr.
					aCollection := SmockMagma collect: 5 stringLimit: 50 depth: depth.
					Transcript show: 'Image size AFTER creating test object: ', self imageSize; cr.
					Transcript show: 'Saving 5 next objects from collection to magma collection...';cr.
					self magmaSession 
							commit: [ ( self magmaSession root at: aKey) addAll: aCollection ].
					Transcript show: 'Image size BEFORE Magma cleaning: ', self imageSize; cr.
					self magmaSession stubOut: aCollection.
					aCollection := nil.
					(Delay forSeconds: 2) wait. "Wait for GC (perhaps it is not necessary)"
					Smalltalk garbageCollect.
					self magmaSession finalizeOids.
					Transcript show: 'Image size AFTER Magma cleaning: ', self imageSize; cr. ]! !

!MagmaMemoryTest methodsFor: 'convenience' stamp: 'JMB 8/7/2007 16:00'!
closeRepository
		"Close the magma repository"
	Transcript show: 'Closing repository';cr.
	self magmaSession notNil
 		  ifTrue:[ 
				self magmaSession closeRepository.
   		          self magmaSession: nil.
             		Smalltalk garbageCollect]! !

!MagmaMemoryTest methodsFor: 'convenience' stamp: 'JMB 8/7/2007 16:00'!
closeSession

	Transcript show: 'Closing magma session';cr.
	self magmaSession notNil
		   ifTrue:[ self magmaSession disconnect. 
				   self magmaSession: nil]! !

!MagmaMemoryTest methodsFor: 'convenience' stamp: 'JMB 8/3/2007 21:01'!
imageSize
	^ (SmalltalkImage current vmParameterAt: 3) asString ! !

!MagmaMemoryTest methodsFor: 'accessing' stamp: 'JMB 8/7/2007 15:58'!
magmaSession
	^magmaSession! !

!MagmaMemoryTest methodsFor: 'accessing' stamp: 'JMB 8/7/2007 15:58'!
magmaSession: aSession
	magmaSession := aSession! !

!MagmaMemoryTest methodsFor: 'prompt' stamp: 'hfm 8/7/2007 13:41'!
promptDepth

	^ (FillInTheBlank 
			request: (String streamContents:
				[ : stream |
					stream
						nextPutAll: 'Enter the depth levels of the object tree:' ])
				initialAnswer: '2') 
! !

!MagmaMemoryTest methodsFor: 'prompt' stamp: 'hfm 8/7/2007 13:33'!
promptHowManyObjects.

	^ (FillInTheBlank 
			request: (String streamContents:
				[ : stream |
					stream
						nextPutAll: 'Enter how many objects do you want to create:' ])
				initialAnswer: '10') ! !

!MagmaMemoryTest methodsFor: 'test' stamp: 'JMB 8/7/2007 17:35'!
testMagmaImageSize
	"MagmaMemoryTest debug: #testMagmaImageSize
	"

	| aKey pathName |
	pathName := FileDirectory default fullNameFor: 'MagmaMemoryTest'.
	Transcript show: 'Creating magma repository';cr.
	MagmaRepositoryController
	    create: pathName
	    root: Dictionary new.
	Transcript show: 'Opening magma session';cr.
	self magmaSession: (MagmaSession openLocal: pathName ).
	self  magmaSession connectAs: 'test'.
	Transcript show: 'Image size before creating magma collection: ', self imageSize; cr.
	aKey := 'MagmaMemoryTest'.
	Transcript show:'Creating magma collection at ', aKey asString;cr.
	self magmaSession 
			commit: [ self magmaSession root at: aKey asString put: MagmaCollection new ].
	self addTestObjects: 50 withDepth: 5 forCollectionAt: aKey! !

!MagmaMemoryTest methodsFor: 'test' stamp: 'JMB 8/7/2007 17:33'!
testMagmaImageSizeParametrized
	" MagmaMemoryTest debug: #testMagmaImageSizeParametrized 
	"

	| aKey objects depth pathName |
	pathName := FileDirectory default fullNameFor: 'MagmaMemoryTest'.
	Transcript show: 'Creating magma repository';cr.
	MagmaRepositoryController
	    create: pathName
	    root: Dictionary new.
	Transcript show: 'Opening magma session';cr.
	self magmaSession: (MagmaSession openLocal: pathName).
	self  magmaSession connectAs: 'test'.
	objects := self promptHowManyObjects asNumber.
	depth := self promptDepth asNumber.
	aKey := 'MagmaMemoryTest'.
	Transcript show:'Creating magma collection at ', aKey asString;cr.
	self magmaSession 
			commit: [ self magmaSession root at: aKey asString put: MagmaCollection new ].
	self addTestObjects: objects withDepth: depth forCollectionAt: aKey
		
! !

Object subclass: #SmockMagma
	instanceVariableNames: 'string one two three four five'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MagmaMemoryTest'!

!SmockMagma commentStamp: '<historical>' prior: 0!
string: colaborador que puede ser usado como clave
one ...five colaborador que se puede usar para ramificar la cadena de colaboradores!

!SmockMagma class methodsFor: 'instance creation' stamp: 'JMB 8/7/2007 16:16'!
collect: aSize stringLimit: aSizeLimit depth: aDepthNumber
		"Answer <aSize> instances with string chain of at the most <aSizeLimit> characters and 
<aDepthNumber> collaborators depth "
	^(1 to: aSize)
			collect: [ : each | self stringLimit: aSizeLimit depth: aDepthNumber ]! !

!SmockMagma class methodsFor: 'random' stamp: 'JMB 8/7/2007 14:24'!
randomCharacter
		"Answer a Random alphanumeric character - needs Works"
	| aCode |
	aCode := 33 + 94 atRandom.
	^Character codePoint: aCode! !

!SmockMagma class methodsFor: 'random' stamp: 'JMB 8/7/2007 14:22'!
randomString: aNumber
		"Answer a random string of size between 1 and <aNumber>"
	^String streamContents: [ :aStream |
			1 to: aNumber atRandom do: [: each | aStream nextPut: self randomCharacter]]! !

!SmockMagma class methodsFor: 'instance creation' stamp: 'JMB 8/7/2007 16:17'!
stringLimit: aSizeLimit depth: aDepthNumber
		"Answer a instance with string chain of at the most <aSizeLimit> characters and 
<aDepthNumber> collaborators depth "
	^self new 
			stringLimited: aSizeLimit;
			fillWithDepth: aDepthNumber;
			yourself! !

!SmockMagma methodsFor: 'creating' stamp: 'JMB 8/7/2007 16:11'!
createFiveWithDepth: aNumber
		"Fill the the reciever five with depth <aNumber>"
	five:= self smockMagmaWithDepth: aNumber
	! !

!SmockMagma methodsFor: 'creating' stamp: 'JMB 8/7/2007 16:11'!
createFourWithDepth: aNumber
			"Fill the the reciever four with depth <aNumber>"
	four := self smockMagmaWithDepth: aNumber
	
	! !

!SmockMagma methodsFor: 'creating' stamp: 'JMB 8/7/2007 16:11'!
createOneWithDepth: aNumber
		"Fill the the reciever one with depth <aNumber>"
	one := self smockMagmaWithDepth: aNumber
	
	! !

!SmockMagma methodsFor: 'creating' stamp: 'JMB 8/7/2007 16:12'!
createThreeWithDepth: aNumber
		"Fill the the reciever three with depth <aNumber>"
	three := self smockMagmaWithDepth: aNumber
	
	! !

!SmockMagma methodsFor: 'creating' stamp: 'JMB 8/7/2007 16:12'!
createTwoWithDepth: aNumber
		"Fill the the reciever two with depth <aNumber>"
	two := self smockMagmaWithDepth: aNumber
	
	! !

!SmockMagma methodsFor: 'creating' stamp: 'JMB 8/7/2007 16:12'!
fillWithDepth: aDepthNumber
		"Fill the receiver collaborators with depth <aDepthNumber>"
	self createOneWithDepth: aDepthNumber.
	self createTwoWithDepth: aDepthNumber.
	self createThreeWithDepth: aDepthNumber.
	self createFourWithDepth: aDepthNumber.
	self createFiveWithDepth: aDepthNumber! !

!SmockMagma methodsFor: 'accessing' stamp: 'JMB 8/3/2007 16:41'!
five
	^five! !

!SmockMagma methodsFor: 'accessing' stamp: 'JMB 8/3/2007 16:41'!
five: anObject
	five := anObject! !

!SmockMagma methodsFor: 'accessing' stamp: 'JMB 8/3/2007 16:41'!
ford
	^ford! !

!SmockMagma methodsFor: 'accessing' stamp: 'JMB 8/3/2007 16:41'!
ford: anObject
	ford := anObject! !

!SmockMagma methodsFor: 'initialize-release' stamp: 'JMB 8/7/2007 16:10'!
initialize
		"Private - Intialize the receiver"
	super initialize.
	string := self randomString: 20.! !

!SmockMagma methodsFor: 'accessing' stamp: 'JMB 8/3/2007 16:35'!
one
	^one! !

!SmockMagma methodsFor: 'accessing' stamp: 'JMB 8/3/2007 16:35'!
one: anObject
	one := anObject! !

!SmockMagma methodsFor: 'random' stamp: 'JMB 8/7/2007 14:22'!
randomString: aNumber
		"Answer a random string of size between 1 and <aNumber>"
	^self class randomString: aNumber! !

!SmockMagma methodsFor: 'creating' stamp: 'JMB 8/7/2007 16:13'!
smockMagmaWithDepth: aNumber
		"Private - Answer a SmockMagma with depth <aNumber>"
	| aSmockMagma depth |
	(aNumber < 1) ifTrue: [ ^nil ].
	aSmockMagma := self class new.
	depth := aNumber -1.
	aSmockMagma createOneWithDepth: depth.
	aSmockMagma createTwoWithDepth: depth.
	aSmockMagma createThreeWithDepth: depth.
	aSmockMagma createFourWithDepth: depth.
	aSmockMagma createFiveWithDepth: depth.
	^aSmockMagma
	
	! !

!SmockMagma methodsFor: 'accessing' stamp: 'JMB 8/3/2007 16:41'!
string
	^string! !

!SmockMagma methodsFor: 'creating' stamp: 'JMB 8/7/2007 16:14'!
stringLimited: aNumber
		"Set the receiver string with a random String of size between 1 and <aNumer>"
	self string: (self randomString: aNumber)
	! !

!SmockMagma methodsFor: 'accessing' stamp: 'JMB 8/3/2007 16:41'!
string: anObject
		"String que puede ser usado como clave"
	string := anObject! !

!SmockMagma methodsFor: 'accessing' stamp: 'JMB 8/3/2007 16:41'!
three
	^three! !

!SmockMagma methodsFor: 'accessing' stamp: 'JMB 8/3/2007 16:41'!
three: anObject
	three := anObject! !

!SmockMagma methodsFor: 'accessing' stamp: 'JMB 8/3/2007 16:40'!
two
	^two! !

!SmockMagma methodsFor: 'accessing' stamp: 'JMB 8/3/2007 16:40'!
two: anObject
	two := anObject! !
